﻿// Notwendige Pakete
var express = require("express");
var bodyParser = require('body-parser');
var fs = require('fs');
var http = require('http');

// Node.js Webserver mit CORS Unterstützung
var app = express();
app.use(bodyParser.urlencoded({extended: true}));
app.use(bodyParser.json());
app.use(function(req, res, next) {
	res.header("Access-Control-Allow-Origin", "*");
	res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
	next();
});

// Einlesen der Benutzerinformationen
var users = [];
try {
	users = JSON.parse(fs.readFileSync('users.json'));
} 
catch(err){
	users = [];
}
console.log(users);

// Login/Registrierung
app.post("/login", function(request, response) {
	var result = {
		state: "FAILED"
	};
	if (request.body.username != undefined && 
		request.body.password != undefined){
		var user; // User bereits registriert?
		for (var i = 0; i < users.length; i++){
			if (users[i].name == request.body.username){
				user = users[i];
				break;
			}
		}
		if (user != undefined){ // registriert -> Passwort-Check
			if (user.pass != request.body.password)
				result.error = "Falsches Passwort";
			else{
				result.state = "OK";
				result.user = user.name;
				result.data = user.data;
			}
		}
		else{ // noch nicht registriert --> User erzeugen
			var user = {
				name: request.body.username,
				pass: request.body.password,
				data: {}
			};
			users.push(user);
			// Speichern
			fs.writeFileSync('users.json', JSON.stringify(users));
			result.state = "OK";
			result.user = user.name;
			result.data = user.data;
		}
			
	}
	response.send(result);
});

// Speichern des Ergebnisses
app.post("/savescore", function(request, response) {
	var result = {
		state: "FAILED"
	};
	if (request.body.username != undefined &&
		request.body.date != undefined &&
		request.body.score != undefined){
		var user;
		for (var i = 0; i < users.length; i++){
			if (users[i].name == request.body.username){
				user = users[i];
				break;
			}
		}
		if (user != undefined){ // nur für registrierte Benutzer
			if (user.data.score == undefined)
				user.data.score = [];
			var score = {
				date: request.body.date,
				time: request.body.score
			};
			user.data.score.push(score);
			fs.writeFileSync('users.json', JSON.stringify(users));
			result.state = "OK";
			result.user = user.name;
			result.data = user.data;
		}
	}
	response.send(result);
});

var server = http.createServer(app);
server.listen(8080);

var WebSocketServer = require('websocket').server;
var wsServer = new WebSocketServer({
    httpServer: server
});
var clients = {};
wsServer.on('request', function(request){ // neue eingehende Verbindung
	console.log(request.origin);
    var connection = request.accept('echo-protocol', request.origin);
	var client = {
		socket: connection,
		username: ""
	};
	connection.on('message', function(message) { // eingehende Message auf dieser Verbindung
		console.log("Message: " + message.utf8Data);
		var data = JSON.parse(message.utf8Data);
		if (data.action == "login"){
			client.username = data.username;
			clients[data.username] = client;
			var data = {
				action: "broadcast",
				username: "nodejs-server",
				msg: client.username + " eingeloggt"
			};
			for(var ci in clients) // Info an alle
				clients[ci].socket.sendUTF(JSON.stringify(data));
		}
		else if (data.action == "broadcast") {
			for(var ci in clients)
				clients[ci].socket.sendUTF(message.utf8Data);
		}
	});
	connection.on('close', function(reasonCode, description) { // Trennung der Verbindung
		delete clients[client.username];
		console.log(client.username + ' disconnected');
		var data = {
			action: "broadcast",
			username: "nodejs-server",
			msg: client.username + " ausgeloggt"
		};
		for(var ci in clients) // Info an alle
			clients[ci].socket.sendUTF(JSON.stringify(data));
	});
});